package org.netkernel.http.rest;

import java.io.ByteArrayOutputStream;
import java.security.DigestOutputStream;
import java.security.MessageDigest;
import java.util.zip.GZIPOutputStream;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.NullOutputStream;
import org.netkernel.layer0.util.Utils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class EtagAccessor extends StandardAccessorImpl
{
	public EtagAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IReadableBinaryStreamRepresentation rbs=aContext.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		String format=aContext.source("arg:operator", String.class);
		MessageDigest md = MessageDigest.getInstance(format);
		DigestOutputStream dos=new DigestOutputStream(new NullOutputStream(), md);
		rbs.write(dos);
		dos.flush();
		String eTag="\""+Utils.toHexString(md.digest())+"\"";
		aContext.createResponseFrom(eTag);
	}
	
	
}
