package org.netkernel.http.rest;

import java.io.ByteArrayOutputStream;
import java.util.zip.GZIPOutputStream;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.Utils;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class GZIPCompressorAccessor extends StandardAccessorImpl
{
	public GZIPCompressorAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		IReadableBinaryStreamRepresentation rbs=aContext.source("arg:operand", IReadableBinaryStreamRepresentation.class);
		ByteArrayOutputStream baos=new ByteArrayOutputStream(2048);
		GZIPOutputStream zos=new GZIPOutputStream(baos);
		Utils.pipe(rbs.getInputStream(), zos);
		ByteArrayRepresentation bar=new ByteArrayRepresentation(baos.toByteArray());
		aContext.createResponseFrom(bar);
	}
	
	
}
