package org.netkernel.http.session;

import java.util.ConcurrentModificationException;
import java.util.Iterator;
import java.util.Map;

import org.netkernel.container.IKernel;
import org.netkernel.container.ILogger;
import org.netkernel.layer0.bnf.BNFGrammarFactory;
import org.netkernel.layer0.bnf.GrammarParseException;
import org.netkernel.layer0.bnf.IGrammarGroup;
import org.netkernel.layer0.meta.GrammarException;
import org.netkernel.layer0.meta.IIdentifierGrammar;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class HTTPSessionMetadataEndpoint extends StandardAccessorImpl
{
	//public static final String SESSION_STATUS_ID="active:httpSessionStatus";
	
	HTTPSessionOverlay mSessionContext;
	
	public HTTPSessionMetadataEndpoint(HTTPSessionOverlay aContext, IKernel aKernel) throws Exception
	{	mSessionContext=aContext;
		this.declareName("SessionMetadataEndpoint");
		this.declareDescription("Provides statistics for the HTTP sessions");
		this.declareThreadSafe();
		this.declareSourceRepresentation(IHDSNode.class);
		IGrammarGroup g1=BNFGrammarFactory.createGroup(null);
		BNFGrammarFactory.createText(g1, "active:httpSessionStatus");
		ILogger logger=aKernel.getLogger();
		IIdentifierGrammar g=BNFGrammarFactory.createGrammar(g1,logger);
		declareGrammar(g);
		setParameterRaw("id", "http:session:metadata", aKernel);
		
	}
	
	public void onSource(INKFRequestContext helper) throws Exception
	{	INKFResponse resp=helper.createResponseFrom(mSessionContext.getSessionStatus());
		resp.setMimeType("text/xml");
		resp.setExpiry(INKFResponse.EXPIRY_MIN_CONSTANT_DEPENDENT, System.currentTimeMillis()+5000);  //Cache for 5 seconds
	}
}
